//--------------------------------------------------------------------
// UTCN, Catedra de Calculatoare
// Sisteme de intrare/iesire si echipamente periferice
//--------------------------------------------------------------------
// http://users.utcluj.ro/~baruch/ro/pages/cursuri/sisteme-de-intrareiesire/laborator.php
//--------------------------------------------------------------------
// Fisier:		TestPort.cpp
// Data:		17.08.2005
// Modificat:	20.02.2009
//--------------------------------------------------------------------
// Testarea porturilor paralele cu adresele de baza 378h si 278h
//--------------------------------------------------------------------
// - Exemplu de aplicatie pentru ilustrarea accesului la porturi
// - Se utilizeaza driverul PortTalk pentru accesul la porturi
//--------------------------------------------------------------------
// - Functii Win32 API utilizate:
//   GetTextMetrics, TextOut
//--------------------------------------------------------------------
// - Sistem de operare: Microsoft Windows 2000/XP
// - Compilator: Microsoft Visual Studio 2008
//--------------------------------------------------------------------

#include <windows.h>
#include "PortTalk_IOCTL.c"

//--------------------------------------------------------------------
// Functia TestPort
//--------------------------------------------------------------------
//
// Functie:		Testeaza existenta porturilor paralele cu adresele
//				de baza 378h si 278h
//
// Parametri:	hWnd - Indicator la fereastra aplicatiei
//				hDc  - Indicator la contextul dispozitivului de afisare
//
// Returneaza:	-
//
//--------------------------------------------------------------------

void TestPort (HWND hWnd, HDC hDc)
{
	TEXTMETRIC tm;				// structura cu metricile pentru afisare
	long cLine;					// inaltimea unei linii de text
	WORD wPort;					// adresa portului
	BYTE byVal;					// valoarea citita de la port
	char szBuffer [50];			// buffer pentru afisare
	int nLung;
	int i;
	BOOL bSucc;

	char szMes1 [] = "Testarea porturilor paralele cu driverul PortTalk";
	char szMes2 [] = "Portul paralel cu adresa de baza %03Xh";
	char szMes3 [] = "Valoarea inscrisa in registrul de date: AAh";
	char szMes4 [] = "Valoarea inscrisa in registrul de date: 55h";
	char szMes5 [] = "Valoarea citita din registrul de date: %02Xh";
	char szMes6 [] = "Portul exista si functioneaza corect";
	char szMes7 [] = "Portul nu exista sau nu functioneaza corect";

	GetTextMetrics (hDc, &tm);	// determina metricile pentru afisare
	cLine = tm.tmHeight + tm.tmExternalLeading;

	OpenPortTalk ();			// initializeaza driverul PortTalk

// Afiseaza mesajul de inceput
	TextOut (hDc, 10, 1*cLine, szMes1, strlen (szMes1));

// Testeaza porturile paralele si afiseaza mesajele
	wPort = 0x378;				// adresa de baza a primului port 
	for (i = 0, bSucc = FALSE; i < 2; i++) {
		nLung = wsprintf (szBuffer, szMes2, wPort);
		TextOut (hDc, 10, (3+i*8)*cLine, szBuffer, nLung);
		outportb (wPort, 0xAA);	// inscrie valoarea in registrul de date
		byVal = inportb (wPort);// citeste valoarea inscrisa
		TextOut (hDc, 10, (5+i*8)*cLine, szMes3, strlen (szMes3));
		nLung = wsprintf (szBuffer, szMes5, byVal);
		TextOut (hDc, 10, (6+i*8)*cLine, szBuffer, nLung);
		if (byVal == 0xAA)
			bSucc = TRUE;
		outportb (wPort, 0x55);	// inscrie valoarea in registrul de date
		byVal = inportb (wPort);// citeste valoarea inscrisa
		TextOut (hDc, 10, (7+i*8)*cLine, szMes4, strlen (szMes4));
		nLung = wsprintf (szBuffer, szMes5, byVal);
		TextOut (hDc, 10, (8+i*8)*cLine, szBuffer, nLung);
		if (bSucc && (byVal == 0x55))
			TextOut (hDc, 10, (9+i*8)*cLine, szMes6, strlen (szMes6));
		else
			TextOut (hDc, 10, (9+i*8)*cLine, szMes7, strlen (szMes7));
		wPort = 0x278;			// adresa de baza a portului al doilea
	}

	ClosePortTalk ();
}